// @link https://www.dataformsjs.com
// @author Conrad Sollitt (http://www.conradsollitt.com)
// @license MIT
"use strict";if(void 0===window.exports&&(window.exports=window),void 0===window.React&&void 0!==window.preact)var React=window.preact;function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _instanceof(e,t){return null!=t&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?!!t[Symbol.hasInstance](e):e instanceof t}function _classCallCheck(e,t){if(!_instanceof(e,t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),e}function _possibleConstructorReturn(e,t){return!t||"object"!==_typeof(t)&&"function"!=typeof t?_assertThisInitialized(e):t}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _getPrototypeOf(e){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&_setPrototypeOf(e,t)}function _setPrototypeOf(e,t){return(_setPrototypeOf=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.DataFormsJS=exports.SortableTable=exports.PolyfillService=exports.LeafletMap=exports.LazyLoad=exports.JsonData=exports.InputFilter=exports.I18n=exports.Format=exports.ErrorBoundary=void 0;var ErrorBoundary=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).state={error:null,errorInfo:null},t}return _inherits(r,React.Component),_createClass(r,[{key:"componentDidCatch",value:function(e,t){this.setState({error:e,errorInfo:t})}},{key:"render",value:function(){return this.state.errorInfo?React.createElement("div",null,React.createElement("h2",{style:{textAlign:"left",color:"white",backgroundColor:"#bc0000",padding:"1em"}},"An error has occurred"),React.createElement("details",{style:{whiteSpace:"pre-wrap",textAlign:"left",color:"white",backgroundColor:"red",padding:"1em"}},this.state.error&&this.state.error.toString(),React.createElement("br",null),this.state.errorInfo.componentStack)):this.props.children}}]),r}();exports.ErrorBoundary=ErrorBoundary;var Format=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"number",value:function(e){return formatNumber(e,{})}},{key:"currency",value:function(e,t){return formatNumber(e,{style:"currency",currency:t,maximumFractionDigits:2})}},{key:"percent",value:function(e,t){var r=1<arguments.length&&void 0!==t?t:0;return formatNumber(e,{style:"percent",maximumFractionDigits:r,minimumFractionDigits:r})}},{key:"date",value:function(e){return formatDateTime(e,{})}},{key:"dateTime",value:function(e){return formatDateTime(e,{year:"numeric",month:"numeric",day:"numeric",hour:"numeric",minute:"numeric",second:"numeric"})}},{key:"time",value:function(e){return formatDateTime(e,{hour:"numeric",minute:"numeric",second:"numeric"})}}]),e}();function isNumber(e){return!isNaN(parseFloat(e))&&isFinite(e)}function formatDateTime(t,r){if(void 0===window.Intl)return t;try{if(_instanceof(t,Date))return new Intl.DateTimeFormat(navigator.language,r).format(t);var e=new Date(t);return new Intl.DateTimeFormat(navigator.language,r).format(e)}catch(e){return console.warn("Error formatting Date/Time Value:"),console.log(navigator.language),console.log(r),console.log(t),console.log(e),"Error"}}function formatNumber(t,r){var e,n,o,a,i,s=null,l=null,c=null;if(i=navigator.language?navigator.language:navigator.userLanguage,null===t||""===t)return null;if(!isNumber(t))return console.warn("Warning value specified in DateFormsJS Handlebars Helper function formatNumber() is not a number:"),console.log(t),t;if(void 0===window.Intl){if(e=r.style?r.style:null,n=r.maximumFractionDigits?r.maximumFractionDigits:0,"percent"===e)return(100*t).toFixed(n)+"%";switch(i){case"en-us":s=",",l=".",c="$"}return null!==s?((o=t.toString().split("."))[0]=o[0].replace(/\B(?=(\d{3})+(?!\d))/g,","),a=o.join(l),"currency"===e?c+a:a):t}try{return new Intl.NumberFormat(i,r).format(t)}catch(e){return console.warn("Error formatting Numeric Value:"),console.log(i),console.log(r),console.log(t),console.log(e),"Error"}}exports.Format=Format;var I18n=function(){function o(e,t){var r=2<arguments.length&&void 0!==arguments[2]?arguments[2]:"_",n=3<arguments.length&&void 0!==arguments[3]?arguments[3]:"i18n";if(_classCallCheck(this,o),"string"!=typeof e)throw new Error("Error - I18n - Missing default locale See examples for usage.");if(!Array.isArray(t))throw new Error("Error - I18n - Missing or invalid supported locales. See examples for usage.");this.state={fileName:r,fileDir:n,defaultLocale:e,supportedLocales:t,currentLocale:null,langText:{},langCache:{},startCallback:null,loadedCallback:null},window.addEventListener("hashchange",this.onHashChange.bind(this)),this.onHashChange()}return _createClass(o,[{key:"onLangStart",value:function(e){this.state.startCallback=e}},{key:"onLangLoaded",value:function(e){this.state.loadedCallback=e}},{key:"onHashChange",value:function(){var n=this,o=this.state,e=null;if(0===window.location.hash.indexOf("#/")&&(""!==(e=window.location.hash.split("/")[1])&&-1!==o.supportedLocales.indexOf(e)||(e=null)),null===e&&(e=o.defaultLocale),o.currentLocale!==e){o.currentLocale=e,this.state.startCallback&&this.state.startCallback();var a=o.fileDir+"/"+o.fileName+"."+o.currentLocale+".json";if(void 0!==o.langCache[a])o.langText=o.langCache[a],n.updatePageTitle(),o.loadedCallback&&o.loadedCallback();else if(void 0!==window.fetch)fetch(a,{mode:"cors",cache:"no-store",credentials:"same-origin"}).then(function(e){var t=e.status;if(200<=t&&t<300||304===t)return Promise.resolve(e);var r="Error loading data. Server Response Code: "+t+", Response Text: "+e.statusText;return Promise.reject(r)}).then(function(e){return e.json()}).then(function(e){o.langCache[a]=e}).catch(function(e){var t="Error Downloading I18N file: ["+a+"], Response Code Status: "+e.message;console.error(t),o.langCache[a]={}}).finally(function(){o.langText=o.langCache[a],n.updatePageTitle(),o.loadedCallback&&o.loadedCallback()});else{console.warn("Using class `I18n` without [jsxLoader.js] or a [fetch] polyfill is being depreciated and will be removed in a future release of DataFormsJS. This is due to the planned removal of <PolyfillService>.");var t=new XMLHttpRequest;t.open("GET",a),t.onload=function(){var t=null;try{var e=this.status;200<=e&&e<300||304===e?o.langCache[a]=JSON.parse(this.responseText):t="Response Status Code: "+e}catch(e){t=e.toString()}if(null!==t){var r="Error Downloading I18N file: ["+a+"], Error: "+t;console.error(r),o.langCache[a]={}}o.langText=o.langCache[a],n.updatePageTitle(),o.loadedCallback&&o.loadedCallback()},t.send()}}}},{key:"updatePageTitle",value:function(){var e=document.querySelector("html title[data-i18n]");e&&(e.textContent=this.text(e.getAttribute("data-i18n"))),document.documentElement.lang=this.state.currentLocale}},{key:"text",value:function(e){return this.state.langText&&this.state.langText[e]?this.state.langText[e]:e}},{key:"currentLocale",get:function(){return this.state.currentLocale}},{key:"getUserDefaultLang",get:function(){if(navigator.languages&&navigator.languages.length&&this.state.supportedLocales&&this.state.supportedLocales.length)for(var e=0,t=navigator.languages.length;e<t;e++)if(-1!==this.state.supportedLocales.indexOf(navigator.languages[e]))return navigator.languages[e];return this.state.defaultLocale}}]),o}();exports.I18n=I18n;var InputFilter=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).onChange=t.onChange.bind(_assertThisInitialized(t)),t.input=React.createRef(),t}return _inherits(r,React.Component),_createClass(r,[{key:"componentDidMount",value:function(){this.filter()}},{key:"onChange",value:function(){this.filter()}},{key:"filter",value:function(){var e=this.input.current,t=e.value.toLowerCase().split(" "),r=t.length,n=0!==r,o=0,a=null,i=null,s=document.querySelectorAll(this.props["filter-selector"]);if(1===s.length&&"TABLE"===s[0].tagName&&s[0].tHead&&1===s[0].tHead.rows.length&&1===s[0].tBodies.length){var l=s[0];a=l.getAttribute("data-sort-class-odd"),i=l.getAttribute("data-sort-class-even"),s=s[0].tBodies[0].rows}for(var c=s.length,u=i&&a,p=0,d=s.length;p<d;p++){var h=s[p],f=!0;if(n)for(var g=h.textContent.toLowerCase(),m=0;m<r;m++)if(""!==t[m]&&!g.includes(t[m])){f=!1;break}f&&(o++,u&&(o%2==0?(h.classList.add(i),h.classList.remove(a)):(h.classList.add(a),h.classList.remove(i)))),h.style.display=f?"":"none"}var v=e.getAttribute("filter-results-selector");if(v){var y=document.querySelector(v);if(!y)return void console.warn("Defined [filter-results-selector] but element not found");var b,C=e.getAttribute("filter-results-text-all"),w=e.getAttribute("filter-results-text-filtered");if(!C)return void console.warn("Defined [filter-results-selector] without [filter-results-text-all]");if(!w)return void console.warn("Defined [filter-results-selector] without [filter-results-text-filtered]");b=(b=o===c?C:w.replace(/{displayCount}/g,o)).replace(/{totalCount}/g,c),y.textContent=b}}},{key:"render",value:function(){return void 0!==window&&window.React===window.preact?React.createElement("input",Object.assign({},this.props,{onInput:this.onChange,ref:this.input})):React.createElement("input",Object.assign({},this.props,{onChange:this.onChange,ref:this.input}))}}]),r}();exports.InputFilter=InputFilter;var jsonDataCache=[],graphQL_Cache={};function saveDataToCache(e,t,r,n){for(var o=0,a=jsonDataCache.length;o<a;o++){var i=jsonDataCache[o];if(i.url===e&&i.query===t)return i.params=JSON.stringify(r),void(i.data=n)}jsonDataCache.push({url:e,query:t,params:JSON.stringify(r),data:n})}function getDataFromCache(e,t,r){for(var n=0,o=jsonDataCache.length;n<o;n++){var a=jsonDataCache[n];if(a.url===e&&a.query===t){if(JSON.stringify(r)===a.params)return a.data;break}}return null}function IsLoading(e){return 0===e.fetchState&&e.children?e.children:null}function HasError(e){if(!(-1===e.fetchState)||!e.children)return null;var t=e.error;return"string"==typeof t&&-1===t.indexOf("Error")&&(t="Error - "+t),React.cloneElement(e.children,{error:t})}function IsLoaded(e){return 1===e.fetchState&&e.children?React.cloneElement(e.children,{data:e.data,params:e.params,handleChange:e.handleChange}):null}var JsonData=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e)))._isFetching=!1,t._isMounted=!1,t.fetchData=t.fetchData.bind(_assertThisInitialized(t)),t.handleChange=t.handleChange.bind(_assertThisInitialized(t)),t.state={fetchState:0,error:null,params:t.getUrlParams(),data:null},t}return _inherits(r,React.Component),_createClass(r,[{key:"getUrlParams",value:function(){var e={};if(this.props&&!0===this.props.graphQL)return void 0===this.props.variables?{}:this.props.variables;for(var t in this.props)"url"!==t&&"string"==typeof this.props[t]&&(e[t]=this.props[t]);return e}},{key:"componentDidMount",value:function(){if((this._isMounted=!0)===this.props.graphQL&&void 0===this.props.query&&void 0!==this.props.querySrc&&void 0!==graphQL_Cache[this.props.querySrc]&&(this.props.query=graphQL_Cache[this.props.querySrc]),this.props.loadOnlyOnce){var e=getDataFromCache(this.props.url,this.props.query,this.getUrlParams());if(null!==e)return void this.setState({fetchState:1,data:e})}if(!0!==this.props.graphQL||void 0!==this.props.query||void 0===this.props.querySrc)this.fetchData();else{var t=this.props.querySrc,r=this;fetch(t,null,"text/plain").then(function(e){var t=e.status;if(200<=t&&t<300||304===t)return Promise.resolve(e);var r="Error loading data. Server Response Code: "+t+", Response Text: "+e.statusText;return Promise.reject(r)}).then(function(e){return e.text()}).then(function(e){graphQL_Cache[t]=e,r.props.query=graphQL_Cache[t],r.fetchData()}).catch(function(e){throw new Error("Error Downloading GraphQL Script: ["+t+"], Error: "+e.toString())})}}},{key:"componentDidUpdate",value:function(e,t){var r;!0===this.props.graphQL?r=JSON.stringify(e.variables)!==JSON.stringify(this.props.variables):r=this.buildUrl(t.params)!==this.buildUrl(this.props);r&&this.setState({params:this.getUrlParams()},this.fetchData)}},{key:"componentWillUnmount",value:function(){this._isMounted=!1}},{key:"buildUrl",value:function(e){var t=this.props.url;if(!0!==this.props.graphQL&&0<Object.keys(e).length)for(var r in e)-1<t.indexOf(":"+r)&&(t=t.replace(new RegExp(":"+r,"g"),encodeURIComponent(e[r])));return t}},{key:"fetchData",value:function(){var n=this,e=this.buildUrl(this.state.params);if(!this._isFetching){this._isFetching=!0;var t={mode:"cors",cache:"no-store",credentials:"same-origin"};if(this.props.fetchOptions&&(t=this.props.fetchOptions),this.props.fetchHeaders&&(t.headers=this.props.fetchHeaders),!0===this.props.graphQL){var r=void 0===this.props.variables?{}:this.props.variables;"file://"===window.location.origin||"null"===window.location.origin?(e+=-1===e.indexOf("?")?"?":"&",e+="query="+encodeURIComponent(this.props.query.trim()),e+="&variables="+encodeURIComponent(JSON.stringify(r))):(t.method="POST",void 0===t.headers?t.headers={"Content-Type":"application/json"}:t.headers["Content-Type"]="application/json",t.body=JSON.stringify({query:this.props.query,variables:r}))}this.setState({fetchState:0},function(){n.updateView(),fetch(e,t).then(function(e){var t=e.status;if(200<=t&&t<300||304===t)return Promise.resolve(e);var r="Error loading data. Server Response Code: "+t+", Response Text: "+e.statusText;return Promise.reject(r)}).then(function(e){return e.json()}).then(function(e){var t=!0===n.props.graphQL;if(t&&e.errors&&e.errors.length){var r;if(1===e.errors.length&&e.errors[0].message)r="[GraphQL Error]: "+e.errors[0].message;else r=("string"==typeof n.props.errorTextGraphQLErrors?n.props.errorTextGraphQLErrors:"{count} GraphQL Errors occured. See console for full details.").replace("{count}",e.errors.length);throw console.error(e.errors),r}n._isMounted&&n.setState({fetchState:1,data:t?e.data:e}),n.props.loadOnlyOnce&&saveDataToCache(n.props.url,n.props.query,n.getUrlParams(),t?e.data:e)}).catch(function(e){n._isMounted&&n.setState({fetchState:-1,error:e.toString()})}).finally(function(){n._isFetching=!1,n.updateView()})})}}},{key:"handleChange",value:function(e){var t=0<arguments.length&&void 0!==e?e:null;this._isMounted&&this.setState({data:null===t?this.state.data:t})}},{key:"updateView",value:function(){if("function"==typeof this.props.onViewUpdated)try{this.props.onViewUpdated()}catch(e){console.error(e)}}},{key:"render",value:function(){return React.createElement(React.Fragment,null,React.createElement(IsLoading,{fetchState:this.state.fetchState},this.props.isLoading),React.createElement(HasError,{fetchState:this.state.fetchState,error:this.state.error},this.props.hasError),React.createElement(IsLoaded,{fetchState:this.state.fetchState,data:this.state.data,params:this.state.params,handleChange:this.handleChange},this.props.isLoaded))}}]),r}();exports.JsonData=JsonData;var LazyLoad=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).state={isReady:!1},t}return _inherits(r,React.Component),_createClass(r,[{key:"componentDidMount",value:function(){var e=this;this.loadScripts(this.props.scripts,this.props.loadScriptsInOrder).then(function(){e.setState({isReady:!0})})}},{key:"loadScripts",value:function(a,e){function i(a){return new Promise(function(e){for(var t=document.querySelectorAll("link"),r=0,n=t.length;r<n;r++)if("stylesheet"===t[r].rel&&t[r].getAttribute("href")===a)return void e();var o=document.createElement("link");o.rel="stylesheet",o.onload=e,o.onerror=function(){console.error("Error loading CSS File: "+a),e()},o.href=a,document.head.appendChild(o)})}function s(a){return new Promise(function(e){for(var t=document.querySelectorAll("script"),r=0,n=t.length;r<n;r++)if(t[r].getAttribute("src")===a)return void e();var o=document.createElement("script");o.onload=e,o.onerror=function(){console.error("Error loading JS File: "+a),e()},o.src=a,document.head.appendChild(o)})}function l(a){return new Promise(function(e){for(var t=document.querySelectorAll("script[data-src][data-compiler]"),r=0,n=t.length;r<n;r++)if(t[r].getAttribute("data-src")===a)return void e();var o=document.createElement("script");o.type="text/babel",o.setAttribute("src",a),document.head.appendChild(o),jsxLoader.loadScript(o).then(function(){e()})})}if("string"==typeof a)a=[a];else if(!Array.isArray(a))return console.error("Invalid prop for <LazyLoad>, expected [scripts] to be a string or an array of strings. Check console."),console.log(a),new Promise(function(e){e()});return!0===e?new Promise(function(r){var n=0,o=a.length;!function e(){if(n!==o){var t=a[n];n++,t.endsWith(".js")?s(t).then(e):t.endsWith(".css")?i(t).then(e):t.endsWith(".jsx")?l(t).then(e):(console.error("Invalid Script for <LazyLoad>. Only scripts ending with [js, css, or jsx] can be used. Error URL: "+t),e())}else r()}()}):new Promise(function(e){for(var t=[],r=0,n=a.length;r<n;r++){var o=a[r];o.endsWith(".js")?t.push(s(o)):o.endsWith(".css")?t.push(i(o)):o.endsWith(".jsx")?t.push(l(o)):console.error("Invalid Script for <LazyLoad>. Only scripts ending with [js, css, or jsx] can be used. Error URL: "+o)}Promise.all(t).then(function(){e()})})}},{key:"loadPolyfill",value:function(e,a){return!1===e||void 0===e?new Promise(function(e,t){var r,n,o;r=e,n=t,(o=document.createElement("script")).onload=function(){r()},o.onerror=function(){console.error("Error loading Script: "+a),n()},o.src=a,document.head.appendChild(o)}):new Promise(function(e){e()})}},{key:"render",value:function(){if(!this.state.isReady)return this.props.isLoading?this.props.isLoading:null;if(this.props.children)return this.props.children;if(this.props.isLoaded){if("string"!=typeof this.props.isLoaded)return this.props.isLoaded;var e=this.props.isLoaded,t={};for(var r in this.props)this.props.hasOwnProperty(r)&&"scripts"!==r&&"isLoaded"!==r&&"isLoading"!==r&&(t[r]=this.props[r]);if(void 0!==window&&void 0!==window[e])return React.createElement(window[e],t);if(void 0!==globalThis&&void 0!==globalThis[e])return React.createElement(globalThis[e],t);throw new TypeError("Component <LazyLoad isLoaded="+JSON.stringify(e)+"> was not found. Check if your script is missing or has a compile error.")}throw new TypeError("Missing child nodes or the [isLoaded] property for a <LazyLoad> element.")}}]),r}();exports.LazyLoad=LazyLoad;var LeafletMap=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).div=React.createRef(),t}return _inherits(r,React.Component),_createClass(r,[{key:"componentDidMount",value:function(){for(var e=parseFloat(this.props.latitude),t=parseFloat(this.props.longitude),r=parseInt(this.props.zoom,10),n=this.props.marker,o=[{attr:"latitude",value:e},{attr:"longitude",value:t},{attr:"zoom",value:r}],a=0,i=o.length;a<i;a++)if(isNaN(o[a].value))return console.error("<LeafletMap> - Invalid Prop for ["+o[a].attr+"], value was not a number."),console.log(o[a].attr),void console.log(this.props);var s=L.map(this.div.current).setView([e,t],r);if(L.tileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",{attribution:'&copy; <a href="http://osm.org/copyright" target="_blank">OpenStreetMap</a> contributors'}).addTo(s),null!==n){var l=L.marker([e,t]).addTo(s);n&&l.bindPopup(n),l.openPopup()}}},{key:"render",value:function(){return React.createElement("div",{className:"leaflet-map",ref:this.div})}}]),r}();exports.LeafletMap=LeafletMap;var PolyfillService=function(){function r(e){var t;return _classCallCheck(this,r),t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e)),console.warn("The <PolyfillService> Component/Class is being depreciated and will be removed in a future release of DataFormsJS. Features of this class are now replaced by [jsxLoader.js] and <LazyLoad>."),t.state={isReady:!1},t}return _inherits(r,React.Component),_createClass(r,[{key:"componentDidMount",value:function(){var e=this,t=!!(Array.from&&window.Promise&&window.fetch);this.loadScript(t,"https://polyfill.io/v3/polyfill.min.js?features=Array.from,Array.isArray,Object.assign,URL,fetch,Promise,Promise.prototype.finally,String.prototype.endsWith,String.prototype.startsWith,String.prototype.includes,String.prototype.repeat",function(){e.setState({isReady:!0})})}},{key:"loadScript",value:function(e,n,t){function r(e,t){var r=document.createElement("script");r.onload=function(){e()},r.onerror=function(){console.error("Error loading Script: "+n),t()},r.src=n,document.head.appendChild(r)}if(!1===e||void 0===e){if(void 0===t)return new Promise(function(e,t){r(e,t)});r(t,t)}else{if(void 0===t)return new Promise(function(e){e()});t()}}},{key:"render",value:function(){return this.state.isReady?this.props.children:null}}]),r}();exports.PolyfillService=PolyfillService;var SortableTable=function(){function r(e){var t;return _classCallCheck(this,r),(t=_possibleConstructorReturn(this,_getPrototypeOf(r).call(this,e))).sortColumn=t.sortColumn.bind(_assertThisInitialized(t)),t.table=React.createRef(),t}return _inherits(r,React.Component),_createClass(r,[{key:"componentDidMount",value:function(){this.setupTable()}},{key:"setupTable",value:function(){var e=this.table.current;if(null===e.tHead)return console.warn("Unable to setup sorting for table because there is no <thead> element"),void console.log(e);if(0===e.tHead.rows.length)return console.warn("Unable to setup sorting for table because the <thead> element contained now rows"),void console.log(e);if(0===e.tBodies.length)return console.warn("Unable to setup sorting for table because the <tbody> element is missing"),void console.log(e);if(1!==e.tBodies.length)return console.warn("Unable to setup sorting for table because there can only be one <tbody> element for the table"),void console.log(e);for(var t=e.tHead.rows[e.tHead.rows.length-1],r=0,n=t.cells.length;r<n;r++)t.cells[r].addEventListener("click",this.sortColumn),t.cells[r].style.cursor="pointer"}},{key:"sortColumn",value:function(e){var t=e.target,r=t&&t.parentElement&&t.parentElement.parentElement?t.parentElement.parentElement.parentElement:null;if("TH"!==t.tagName&&"TD"!==t.tagName)return console.warn("SortableTable.sortColumn() was called with an invalid element. If called manually the cell needs to be passed."),void console.log(t);if(null!=r&&"TABLE"!==r.tagName)return console.warn("SortableTable.sortColumn() was called with an invalid element. If called manually the table cell of the last row from the table header should be used."),void console.log(t);var n=r.getAttribute("data-sort-column"),o=t.cellIndex,a="asc";null!==n&&parseInt(n,10)===o&&(a="asc"===r.getAttribute("data-sort-order")?"desc":"asc");for(var i=r.tBodies[0],s=i.rows,l=[],c=0,u=s.length;c<u;c++){var p=s[c].cells[o];if(void 0!==p){var d=p.getAttribute("data-value"),h=null!==d?d.trim():p.textContent.trim(),f=_typeof(h);if(""===h)h=null;else if(isNaN(h)){var g=new Date(h);isNaN(g.getTime())?h=void 0!==h.toLocaleLowerCase?h.toLocaleLowerCase():h.toLowerCase():(h=g,f="date")}else h=parseFloat(h);l.push({row:s[c],value:h,type:null===h?null:f})}}l.sort(this.sortCompare),"desc"===a&&l.reverse();for(var m=r.getAttribute("data-sort-class-odd"),v=r.getAttribute("data-sort-class-even"),y=m&&v,b=0,C=0,w=l.length;C<w;C++){var L=l[C].row;y&&"none"!==L.style.display&&(++b%2==0?(L.classList.add(v),L.classList.remove(m)):(L.classList.add(m),L.classList.remove(v))),i.appendChild(L)}r.setAttribute("data-sort-column",o),r.setAttribute("data-sort-order",a)}},{key:"sortCompare",value:function(e,t){return null===e.type&&null!==t.type?-1:null===t.type&&null!==e.type?1:null===e.type&&null===t.type?0:"number"===e.type&&"number"!==t.type?-1:"number"===t.type&&"number"!==e.type?1:"number"===e.type&&"number"===t.type?e.value-t.value:"date"===e.type&&"date"!==t.type?-1:"date"===t.type&&"date"!==e.type?1:"date"===e.type&&"date"===t.type?e.value<t.value?-1:e.value>t.value?1:0:"string"===e.type&&"string"===t.type?void 0!==e.value.localeCompare?e.value.localeCompare(t.value):e.value<t.value?-1:e.value>t.value?1:0:(console.warn("A code change from [SortableTable] impacted sorting and caused an expected error so the data may appear out of order. Please review your code changes"),0)}},{key:"render",value:function(){return React.createElement("table",Object.assign({},this.props,{ref:this.table}),this.props.children)}}]),r}();exports.SortableTable=SortableTable;var DataFormsJS=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"ErrorBoundary",get:function(){return ErrorBoundary}},{key:"Format",get:function(){return Format}},{key:"I18n",get:function(){return I18n}},{key:"InputFilter",get:function(){return InputFilter}},{key:"JsonData",get:function(){return JsonData}},{key:"LazyLoad",get:function(){return LazyLoad}},{key:"LeafletMap",get:function(){return LeafletMap}},{key:"PolyfillService",get:function(){return PolyfillService}},{key:"SortableTable",get:function(){return SortableTable}}]),e}();exports.DataFormsJS=DataFormsJS;